/* */
/*									*/
/*	Copyright (c) 1987,1988,1989,1990,1991,1992   AT&T		*/
/*			All Rights Reserved				*/
/*									*/
/*	  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T.		*/
/*	    The copyright notice above does not evidence any		*/
/*	   actual or intended publication of such source code.		*/
/*									*/
/* */
/*
 *	static char *ID_instabh = "@(#) instab.h: 1.3 12/10/83";
 */

#define SHFT_MSK 0x1F
#define	DUMMY	0x01
#define	INSTRX	0x10
#define	INSTRB	0x11
#define	INSTRH	0x12
#define	INSTRW	0x13
#if	FLOAT
#define	INSTRD	0x14
#endif
#define	INSTRBH	0x15
#define	INSTRBW	0x16
#define	INSTRHW	0x17
#define	INSTRWH	0x18
#define	INSTRWB	0x19
#define	INSTRHB	0x20
/*
 *	the following defines are not needed at this time
 *	but are included for completeness
 *
#if	FLOAT
#define	INSTRHD	0x21
#define	INSTRWD	0x22
#define	INSTRDH	0x23
#define	INSTRDW	0x24
#endif
 *
 */
#define	PSEUDO	0x25
#define	IS25	0x40
#define REGMD		0x1	/* register mode */
#define REGDFMD		0x2	/* register defered mode */
#define IMMD		0x3	/* immediate mode */
#define ABSMD		0x4	/* absolute address mode */
#define ABSDFMD		0x5	/* absolute address deferred mode */
#define EXADMD		0x6	/* external address mode */
#define EXADDFMD	0x7	/* external address deferred mode */
#define DSPMD		0x8	/* displacement mode */
#define DSPDFMD		0x9	/* displacement deferred mode */

#define CREGMD		0x4	/* register mode */
#define CREGDFMD	0x5	/* register deferred mode */
#define CFPDSPMD	0x6	/* FP displacement mode */
#define CAPDSPMD	0x7	/* AP displacement mode */
#define CDSPMD		0x8	/* displacement mode */
#define CDSPDFMD	0x9	/* displacement deferred mode */
#define CHDSPMD		0xA	/* halfword displacement mode */
#define CHDSPDFMD	0xB	/* halfword displacement deferred mode */
#define CBDSPMD		0xC	/* byte displacement mode */
#define CBDSPDFMD	0xD	/* byte displacement deferred mode */
#define CEXPAND		0xE	/* expand byte */
#define CIMMD		0x4F	/* immediate mode */
#define CHIMMD		0x5F	/* halfword immediate  */
#define CBIMMD		0x6F	/* byte immediate  */
#define CABSMD		0x7F	/* absolute address mode */
#define CABSDFMD	0xEF	/* absolute address deferred mode */

#if	FLOAT
#define	FPIMMD		0x13	/* dummy floating point immediate mode */
#define	CDIMMD		0xCF	/* floating point double immediate mode */
#endif

#define FPREG		0x9	/* FP register number */
#define APREG		0xA	/* AP register number */
#define	PSWREG		0xB	/* PSW register number */
#define SPREG		0xC	/* SP register number */
#define	PCREG		0xF	/* PC register number */

#define UBYTE		0x3
#define SBYTE		0x7
#define UHALF		0x2
#define SHALF		0x6
#define UWORD		0x0
#define SWORD		0x4
#define NOTYPE		0xF	/* no new type (i.e. {...}) specified */

#define JMPOPCD 0x24L

#define	NULLSPEC	0x00L
#define BYTESPEC	0x01L
#define	HALFSPEC	0x02L
#define	WORDSPEC	0x03L
#define	LITERALSPEC	0x04L
#define	SHORTSPEC	0x05L

typedef struct {
	short	exptype;
	symbol	*symptr;
	int32_t	expval;		/* holds value of integer expression, coded
				 float or first word of a double constant */
#if	FLOAT
	int32_t	fdexpval2;	/* holds second word of a double constant */
#endif
	/*	variables that may be needed in future fp releases
	 * short fptype;	1=single fp ; 2=double fp constant
	 * double fpexpval;	holds value of floating point expression
	 */
} rexpr;

typedef struct {
	short newtype; /* only need BYTE, but short keeps the structure even */
	BYTE admode;
	BYTE adreg;
	rexpr adexpr;
	/*
	 * The expression specifier describes the size of the expression
	 * and is kept here.
	 */
	int32_t	expspec;
} addrmode;

short ato3bf(char *string, rexpr *lp);

int pswcheck(instr *insptr, addrmode *addr);
void intaft1check(addrmode *opnd, short mtoreg);
void addrgen(instr *insptr,addrmode *addr,short expand,short opnum);
void pcintcheck(instr *insptr,addrmode *dest);
void pushopgen(instr *insptr,addrmode *opnd1);
void mulchk3(instr *insptr,addrmode *addr1,addrmode *addr2,addrmode *addr3);
void intaft2check(addrmode *opnd1, addrmode *opnd2, short mtoreg);
int mtoregcheck(addrmode *src, addrmode *dest);
void shftopgen(instr *insptr,addrmode *opnd1,addrmode *opnd2,addrmode *opnd3);
void opt21gen(instr *insptr,addrmode *addr1,addrmode *addr2,short constant);
void convgen(instr *insptr, addrmode *addr1, addrmode *addr2);
int optype(BYTE instype,short opnum);
void er21(instr *insptr,addrmode *addr1,addrmode *addr2,addrmode *addr3);
int er16fix(instr *insptr,addrmode *arg1, addrmode *arg2, addrmode *arg3);
void jmpopgen(instr *insptr,addrmode *opnd1);
void jsbopgen(instr *insptr,addrmode *opnd1);
void loop1gen(instr *insptr,addrmode *index,addrmode *incr,addrmode *limit,addrmode *dest);
void loop2gen(instr *insptr,addrmode *index, addrmode *incr,addrmode *dest);
void blockgen(instr *insptr);
void testgen(instr *insptr, addrmode *addr1);
void callgen(instr *insptr,addrmode *imm,addrmode *dest);
void fpdtos(rexpr *fpval);
void comment(char *string);
void pcintcheck(instr *insptr,addrmode *dest);

int32_t swap_b4(int32_t val);
